Qwt User's Guide: QwtSplineC2 Class Reference

Qwt User's Guide 6.3.0

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
QwtSplineC2 Class Referenceabstract

Base class for spline interpolations providing a second order parametric continuity ( C2 ) between adjoining curves. More...

`#include <qwt_spline.h>`

Inheritance diagram for QwtSplineC2:

## Public Types
enum | BoundaryConditionC2 { CubicRunout = LinearRunout + 1 , NotAKnot }
Public Types inherited from QwtSpline
enum | BoundaryType { ConditionalBoundaries , PeriodicPolygon , ClosedPolygon }
enum | BoundaryPosition { AtBeginning , AtEnd }
enum | BoundaryCondition { Clamped1 , Clamped2 , Clamped3 , LinearRunout }
| Boundary condition. More...

## Public Member Functions
| QwtSplineC2 ()
| Constructor.
virtual | ~QwtSplineC2 ()
| Destructor.
virtual QPainterPath | painterPath (const QPolygonF &) const override
| Interpolate a curve with Bezier curves.
virtual QVector< QLineF > | bezierControlLines (const QPolygonF &) const override
| Interpolate a curve with Bezier curves.
virtual QPolygonF | equidistantPolygon (const QPolygonF &, double distance, bool withNodes) const override
| Find an interpolated polygon with "equidistant" points.
virtual QVector< QwtSplinePolynomial > | polynomials (const QPolygonF &) const override
| Calculate the interpolating polynomials for a non parametric spline.
virtual QVector< double > | slopes (const QPolygonF &) const override
| Find the first derivative at the control points.
virtual QVector< double > | curvatures (const QPolygonF &) const =0
| Find the second derivative at the control points.
Public Member Functions inherited from QwtSplineC1
| QwtSplineC1 ()
| Constructor.
virtual | ~QwtSplineC1 ()
| Destructor.
virtual double | slopeAtBeginning (const QPolygonF &, double slopeNext) const
virtual double | slopeAtEnd (const QPolygonF &, double slopeBefore) const
Public Member Functions inherited from QwtSplineG1
| QwtSplineG1 ()
| Constructor.
virtual | ~QwtSplineG1 ()
| Destructor.
Public Member Functions inherited from QwtSplineInterpolating
| QwtSplineInterpolating ()
| Constructor.
virtual | ~QwtSplineInterpolating ()
| Destructor.
virtual QPolygonF | polygon (const QPolygonF &, double tolerance) const override
| Interpolate a curve by a polygon.
Public Member Functions inherited from QwtSpline
| QwtSpline ()
| Constructor.
virtual | ~QwtSpline ()
| Destructor.
void | setParametrization (int type)
void | setParametrization (QwtSplineParametrization *)
const QwtSplineParametrization * | parametrization () const
void | setBoundaryType (BoundaryType)
BoundaryType | boundaryType () const
void | setBoundaryValue (BoundaryPosition, double value)
| Define the boundary value.
double | boundaryValue (BoundaryPosition) const
void | setBoundaryCondition (BoundaryPosition, int condition)
| Define the condition for an endpoint of the spline.
int | boundaryCondition (BoundaryPosition) const
void | setBoundaryConditions (int condition, double valueBegin=0.0, double valueEnd=0.0)
| Define the condition at the endpoints of a spline.
virtual uint | locality () const

## Detailed Description

Base class for spline interpolations providing a second order parametric continuity ( C2 ) between adjoining curves.

All interpolations with C2 continuity are based on rules for finding the 2. derivate at some control points.

In case of non parametric splines those points are the curve points, while for parametric splines the calculation is done twice using a parameter value t.

See also
  QwtSplineParametrization

Definition at line 267 of file qwt_spline.h.

## Member Enumeration Documentation

## ◆ BoundaryConditionC2

enum QwtSplineC2::BoundaryConditionC2

Boundary condition that requires C2 continuity

See also
  QwtSpline::boundaryCondition, QwtSpline::BoundaryCondition

Enumerator
CubicRunout | The second derivate at the endpoint is related to the second derivatives at the 2 neighbours: cv[0] := 2.0 * cv[1] - cv[2]. Note boundaryValue() is ignored
NotAKnot | The 3rd derivate at the endpoint matches the 3rd derivate at its neighbours. Or in other words: the first/last curve segment extents the polynomial of its neighboured polynomial Note boundaryValue() is ignored

Definition at line 275 of file qwt_spline.h.

## Constructor & Destructor Documentation

## ◆ QwtSplineC2()

QwtSplineC2::QwtSplineC2 | ( |  | ) |

Constructor.

The default setting is a non closing spline with no parametrization ( QwtSplineParametrization::ParameterX ).

See also
  QwtSpline::setParametrization(), QwtSpline::setBoundaryType()

Definition at line 1228 of file qwt_spline.cpp.

## ◆ ~QwtSplineC2()

QwtSplineC2::~QwtSplineC2 | ( |  | ) |
| virtual

Destructor.

Definition at line 1233 of file qwt_spline.cpp.

## Member Function Documentation

## ◆ bezierControlLines()

QVector< QLineF > QwtSplineC2::bezierControlLines | ( | const QPolygonF & | points | ) | const
| overridevirtual

Interpolate a curve with Bezier curves.

Interpolates a polygon piecewise with cubic Bezier curves and returns the 2 control points of each curve as QLineF.

Parameters

  points | Control points

Returns
  Control points of the interpolating Bezier curves

Note
  The implementation simply calls QwtSplineC1::bezierControlLines(), but is intended to be replaced by a more efficient implementation that builds the polynomials by the curvatures some day.

Reimplemented from QwtSplineC1.

Reimplemented in QwtSplineCubic.

Definition at line 1270 of file qwt_spline.cpp.

## ◆ curvatures()

QVector< double > QwtSplineC2::curvatures | ( | const QPolygonF & | points | ) | const
| pure virtual

Find the second derivative at the control points.

Parameters

  points | Control nodes of the spline

Returns
  Vector with the values of the 2nd derivate at the control points

See also
  slopes()

Note
  The x coordinates need to be increasing or decreasing

Implemented in QwtSplineCubic.

## ◆ equidistantPolygon()

QPolygonF QwtSplineC2::equidistantPolygon | ( | const QPolygonF & | points,
|  | double | distance,
|  | bool | withNodes ) const
| overridevirtual

Find an interpolated polygon with "equidistant" points.

The implementation is optimzed for non parametric curves ( QwtSplineParametrization::ParameterX ) and falls back to QwtSpline::equidistantPolygon() otherwise.

Parameters

  points | Control nodes of the spline
  distance | Distance between 2 points according to the parametrization
  withNodes | When true, also add the control nodes ( even if not being equidistant )

Returns
  Interpolating polygon

See also
  QwtSpline::equidistantPolygon()

Reimplemented from QwtSplineC1.

Definition at line 1295 of file qwt_spline.cpp.

## ◆ painterPath()

QPainterPath QwtSplineC2::painterPath | ( | const QPolygonF & | points | ) | const
| overridevirtual

Interpolate a curve with Bezier curves.

Interpolates a polygon piecewise with cubic Bezier curves and returns them as QPainterPath.

Parameters

  points | Control points

Returns
  Painter path, that can be rendered by QPainter

Note
  The implementation simply calls QwtSplineC1::painterPath(), but is intended to be replaced by a one pass calculation some day.

Reimplemented from QwtSplineC1.

Reimplemented in QwtSplineCubic.

Definition at line 1249 of file qwt_spline.cpp.

## ◆ polynomials()

QVector< QwtSplinePolynomial > QwtSplineC2::polynomials | ( | const QPolygonF & | points | ) | const
| overridevirtual

Calculate the interpolating polynomials for a non parametric spline.

C2 spline interpolations are based on finding values for the second derivates of f at the control points. The interpolating polynomials can be calculated from the the second derivates using QwtSplinePolynomial::fromCurvatures.

The default implementation is a 2 pass calculation. In derived classes it might be overloaded by a one pass implementation.

Parameters

  points | Control points

Returns
  Interpolating polynomials

Note
  The x coordinates need to be increasing or decreasing

Reimplemented from QwtSplineC1.

Reimplemented in QwtSplineCubic.

Definition at line 1381 of file qwt_spline.cpp.

## ◆ slopes()

QVector< double > QwtSplineC2::slopes | ( | const QPolygonF & | points | ) | const
| overridevirtual

Find the first derivative at the control points.

An implementation calculating the 2nd derivatives and then building the slopes in a 2nd loop. QwtSplineCubic overloads it with a more performant implementation doing it in one loop.

Parameters

  points | Control nodes of the spline

Returns
  Vector with the values of the 1nd derivate at the control points

See also
  curvatures()

Note
  The x coordinates need to be increasing or decreasing

Implements QwtSplineC1.

Reimplemented in QwtSplineCubic.

Definition at line 1339 of file qwt_spline.cpp.